// zGoGUIView.h : interface of the CZGoGUIView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ZGOGUIVIEW_H__B79EE38C_A56B_4F2A_824D_5D4F3CC52EC1__INCLUDED_)
#define AFX_ZGOGUIVIEW_H__B79EE38C_A56B_4F2A_824D_5D4F3CC52EC1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "config.h"
#include "gnugo.h"

#include "zGo.h"
#include "zGoBoard.h"
#include "zMessageBox.h"
#include "zDlgGameOptions.h"
#include "zTimer.h"


extern "C" {
	int linkMain(zGoOption *_goOption, int argc, char *argv[]);
	void setGameOption(zGoOption *_goOption);
	void z_do_pass(int *passes, int _color);
	void z_computer_move(int *passes, int _color, int *_i, int *_j);
	void z_user_move(int x, int y, int color);
	void z_undo_move();
	int  z_get_last_move_i();
	int  z_get_last_move_j();
	int  z_get_last_move_color();
	int z_load_file(char* fileName);
	int z_save_file(char* fileName);
	void getGoData(zGoData *_goData);
	void zScore(zGoData *_goData);
}

// PARAMETER TO THREAD
typedef struct {
	int passes;
	int currentColor;
	int i;
	int j;
	HWND m_hwndDrawBoard;
	HANDLE m_hEventKillComputerPlayBothThread;
	HANDLE m_hEventComputerPlayBothThreadKilled;
} MovePara;
#define WM_DRAW_BOARD (WM_USER + 2)
#define WM_SHIFT_TIMER (WM_USER + 3)
#define WM_SET_CURRENT_COLOR (WM_USER + 4)
// Controlling function for the worker thread.
UINT computerPlayBothProc(LPVOID pParam);


class CZGoGUIView : public CView
{
protected: // create from serialization only
	CZGoGUIView();
	DECLARE_DYNCREATE(CZGoGUIView)

// Attributes
public:
	CZGoGUIDoc* GetDocument();
	CZGoGUIApp* theApp;

	int currentColor;
	int passes;
	int last_i;
	int last_j;
	int last_color;
	int currentMoveNum;
	SGFTree sgftree;
	zGoOption goOption;
	zGoData goData;
	zGoBoard goBoard;
	zDlgGameOptions dlgOption;
	//int dcCreated;
	//CClientDC *dc;
	zTimer bTimer;
	zTimer wTimer;
	CWinThread* m_pComputerPlayBothThread;
	MovePara *movePara;
	HANDLE m_hEventKillComputerPlayBothThread;
	HANDLE m_hEventComputerPlayBothThreadKilled;
	int computerPlayBoth;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CZGoGUIView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void UpdateStatusBar();
	void shiftTimer();
	void goEnd();
	void backWard();
	void forWard();
	void goTop();
	void OpenFile(LPCTSTR lpszPathName);
	void setCurrentColor();
	void drawBoard();
	void drawBoardData(CDC* dc);
	virtual ~CZGoGUIView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
public:
	//{{AFX_MSG(CZGoGUIView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnGoComputermove();
	afx_msg void OnGoOptions();
	afx_msg void OnGoPass();
	afx_msg void OnGoUndomove();
	afx_msg void OnGoShowdragons();
	afx_msg void OnGoShowworms();
	afx_msg void OnGoScore();
	afx_msg void OnGoComputerplayboth();
	afx_msg void OnGoStopcomputerplayboth();
	afx_msg void OnNevigateTop();
	afx_msg void OnNevigateBackward();
	afx_msg void OnNevigateForward();
	afx_msg void OnNevigateEnd();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in zGoGUIView.cpp
inline CZGoGUIDoc* CZGoGUIView::GetDocument()
   { return (CZGoGUIDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ZGOGUIVIEW_H__B79EE38C_A56B_4F2A_824D_5D4F3CC52EC1__INCLUDED_)
