// zMessageBox.cpp : implementation file
//

#include "stdafx.h"
#include "zGoGUI.h"
#include "zMessageBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


zMessageBox m_messageBox;

//////////////////////////////////////////////////////////////////////
// Static data members must be initialized at file scope, even
//    if private.
BOOL zMessageBox::m_messageBoxCreated=FALSE;
BOOL zMessageBox::m_messageBoxShown=TRUE;

/////////////////////////////////////////////////////////////////////////////
// zMessageBox dialog


zMessageBox::zMessageBox(CWnd* pParent /*=NULL*/)
	: CDialog(zMessageBox::IDD, pParent)
{
	//{{AFX_DATA_INIT(zMessageBox)
	m_edit1 = _T("");
	//}}AFX_DATA_INIT
}


void zMessageBox::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(zMessageBox)
	DDX_Control(pDX, IDC_EDIT1, m_editControl1);
	DDX_Text(pDX, IDC_EDIT1, m_edit1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(zMessageBox, CDialog)
	//{{AFX_MSG_MAP(zMessageBox)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// zMessageBox message handlers

BOOL zMessageBox::Message(CString _string1, CString _string2)
{
	try {
		if (!m_messageBoxCreated) {
			m_messageBox.Create(IDD_MESSAGEBOX,NULL);
			m_messageBoxCreated=TRUE;
		}
		if (m_messageBoxShown) {
			m_messageBox.ShowWindow(SW_SHOW);
			CString lineFeed;
			// TO MAKE THIS WORK, SET 'MULTI-LINE' IN DIALOG EDIT COMPONENT
			lineFeed.Format("%c%c", 13,10);

			m_messageBox.m_edit1 += _string1;
			m_messageBox.m_edit1 += _string2;
			m_messageBox.m_edit1 += lineFeed;
			m_messageBox.UpdateData(FALSE);
			int numLines=m_messageBox.m_editControl1.GetLineCount();
			m_messageBox.m_editControl1.LineScroll(numLines-5,0);
			return TRUE;
		}
	}
	catch (...) {
	    AfxMessageBox("MessageBox(CString, CString): error" );
	}
	return FALSE;
}

BOOL zMessageBox::Message(CString _str, int _i)
{
	try {
		CString tmp;
		tmp.Format(" %d ", _i);
		Message(_str, tmp);
		return TRUE;
	}
	catch (...) {
	    AfxMessageBox("ZAppManager::MessageBox(CString, int): error" );
	}
	return FALSE;
}

BOOL zMessageBox::Message(CString _str, float _float)
{
	try {
		CString tmp;
		tmp.Format(" %10.2f ", _float);
		Message(_str, tmp);
		return TRUE;
	}
	catch (...) {
	    AfxMessageBox("ZAppManager::MessageBox(CString, _float): error" );
	}
	return FALSE;
}

BOOL zMessageBox::Message(CString _str, double _double)
{
	try {
		CString tmp;
		tmp.Format(" %10.2f ", _double);
		Message(_str, tmp);
		return TRUE;
	}
	catch (...) {
	    AfxMessageBox("ZAppManager::MessageBox(CString, _double): error" );
	}
	return FALSE;
}
